#!/usr/bin/env python

import os, sys, socket, time
import unittest, unittest_env

import SSH2

class SSH2FingerPrintUnitTest(unittest.TestCase):
	
	def getConnexion(self):
		sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		sock.connect((HOSTNAME, PORT))
		sock.setblocking(1)
		return sock
	
	def testLoginPwd(self):
		ssh = SSH2.Session()
		ssh.setBanner(SSH2.DEFAULT_BANNER+" Python (http://www.keyphrene.com/projects/org.keyphrene)")
		ssh.startup(self.getConnexion())
		ssh.setPassword(LOGIN, PWD)
		channel = ssh.popen(command)
		print channel
		if channel:
			channel.setBlocking(True)
			B = BUFFER
			buf = channel.read(B)
			print buf
			channel.flush()
			channel.close()
		ssh.close()
	
	
	
	def testPublicKey(self):
		ssh = SSH2.Session()
		ssh.setBanner(SSH2.DEFAULT_BANNER+" Python (http://www.keyphrene.com/projects/org.keyphrene)")
		ssh.startup(self.getConnexion())
		ssh.setPublicKey(LOGIN,publickey,privatekey,passphrase)
		channel = ssh.popen(command)
		print channel
		if channel:
			channel.setBlocking(True)
			B = BUFFER
			buf = channel.read(B)
			print buf
			channel.flush()
			channel.close()
		ssh.close()
	
	def testPublicKeyNoPass(self):
		ssh = SSH2.Session()
		ssh.setBanner(SSH2.DEFAULT_BANNER+" Python (http://www.keyphrene.com/projects/org.keyphrene)")
		ssh.startup(self.getConnexion())
		ssh.setPublicKey(LOGIN,publickey_nopass,privatekey_nopass)
		channel = ssh.popen(command)
		print channel
		if channel:
			channel.setBlocking(True)
			B = BUFFER
			buf = channel.read(B)
			print buf
			channel.flush()
			channel.close()
		ssh.close()

if __name__ == "__main__": 
	print
	print "UnitTest: Foreign host fingerprint"
	HOSTNAME = "127.0.0.1"
	PORT = 22
	LOGIN = "tom"
	PWD = "*****"
	BUFFER = 8192
	publickey = "/home/tom/.ssh/id_dsa.pub"
	privatekey = "/home/tom/.ssh/id_dsa"
	passphrase = "*****"
	publickey_nopass = "/home/tom/.ssh/id_rsa.pub"
	privatekey_nopass = "/home/tom/.ssh/id_rsa"
	command = 'echo -e "This is a test\\nAnd it is conclusive."'

	unittest.main()
