#!/usr/bin/env python

import os, sys, socket, time
import unittest, unittest_env

import SSH2

class SSH2methodsUnitTest(unittest.TestCase):
	
	def getConnexion(self):
		sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		sock.connect((HOSTNAME, PORT))
		sock.setblocking(1)
		return sock
	
	def testMethods(self):
		ssh = SSH2.Session()
		errcodes = ssh.bindErrors()
		ssh.setBanner(SSH2.DEFAULT_BANNER+" Python (http://www.keyphrene.com/projects/org.keyphrene)")
		ret = ssh.setMethod(SSH2.METHOD_CRYPT_CS, "blowfish-cbc")
		if ret:
			print "Error: ", errcodes[ret]	
		ret = ssh.setMethod(SSH2.METHOD_CRYPT_SC, "blowfish-cbc")
		if ret:
			print "Error: ", errcodes[ret]	
		ret = ssh.setMethod(SSH2.METHOD_COMP_CS, "zlib,none")
		if ret:
			print "Error: ", errcodes[ret]	
		print ssh.getMethods()
		ssh.startup(self.getConnexion())
		print ssh.getMethods()
		ssh.close()

if __name__ == "__main__": 
	print
	print "UnitTest: Foreign host fingerprint"
	HOSTNAME = "127.0.0.1"
	PORT = 22
	
	unittest.main()
