import os, sys, socket, time
import unittest #, unittest_env

from org.keyphrene import crypto, SSH2

# "direct-tcpip" for client-to-server forwarded connections
# "forwarded-tcpip" for server-to-client forwarded connections (ecoute du serveur ssh sur les entrees)
# /etc/hosts.allow
# sshd: ALL

# Log for SSH
# Set 
# SyslogFacility	AUTH
# LogLevel	DEBUG


class SSH2SFTPUnitTest(unittest.TestCase):
	
	def getConnexion(self):
		sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		sock.connect((HOSTNAME, PORT))
		sock.setblocking(1)
		return sock
	
	def testReadDir(self):
		ssh = SSH2.Session()
		ssh.setBanner(SSH2.DEFAULT_BANNER+" Python (http://www.keyphrene.com/projects/org.keyphrene)")
		#~ ssh.setMethod(SSH2.METHOD_COMP_CS, "zlib")
		ssh.startup(self.getConnexion())
		ssh.setPassword(LOGIN, PWD)
		#~ print ssh.SFTP()
		# tunnel is a channel object, host and port are the target, the other arguments are the source (origin)
		#~ tunnel = ssh.DirectTcpIP("127.0.0.1", 80) #, "127.0.0.1", 32440) 
		print "connect"
		# Un port en Listen sur le local, adresse et port en sortie du serveur SSH
		
		#~ tunnel = ssh.DirectTcpIP("88.191.30.174", 80, "127.0.0.1", 3128) 
		tunnel = ssh.DirectTcpIP("127.0.0.1", 80, "127.0.0.1", 81)
		#~ tunnel = ssh.ForwardListen("127.0.0.1", 81, 82, 10)
		print tunnel
		
		#~ sftp.shutdown()
		ssh.close()
	
	
if __name__ == "__main__": 
	print
	print "UnitTest: SSH2, SFTP, SCP"
	print "Keyphrene.com - 2005 - All rights reserved"
	HOSTNAME = "127.0.0.1"
	PORT = 22
	LOGIN = "login"
	PWD = "password"
	
	unittest.main()
